#********************************************************/
#* Gsh Copyright (C) 1999 Vaughn Cato                   */
#* See the file "LICENSE", included with this software, */
#* for license information.                             */
#********************************************************/
proc let {varname value command} {
  upvar $varname var 
  if {[info exists var]} {
    set oldvalue $var
    uplevel "set $varname \"$value\""
    uplevel $command
    uplevel "set $varname \"$oldvalue\""
  } else {
    uplevel "set $varname \"$value\""
    uplevel $command
    uplevel unset $varname
  }
}
