#********************************************************/
#* Gsh Copyright (C) 1999 Vaughn Cato                   */
#* See the file "LICENSE", included with this software, */
#* for license information.                             */
#********************************************************/
set term_monitor 0

proc create_terminal_widget {args} {
  eval text $args
}

#proc term_mark_row_col {widget index rowvar colvar} {
#  upvar $rowvar row 
#  upvar $colvar col
#  set result [$widget index $index]
#  scan $result "%d.%d" row col
#}

#proc text_see {widget index} {
#  $widget see $index
#}

# You basically only want to allow scrolling if the term is focused, but
# a command can exit, and return focus back to the command line before all
# it's output has been written to the terminal, and you want to also scroll
# in this case.  This has the side effect that output written by a background 
# process can scroll the output, but what can you do?
#proc term_allowed_scroll {this} {
#  upvar #0 $this term
#
#  set focused_term [focused_term $term(widget)]
#  if {$focused_term==$this || ($focused_term=="" && ![term_is_active $this])} {
#    return 1
#  }
#  return 0
#}

#proc term_scroll {this count} {
#  if {[term_allowed_scroll $this]} {
#    [term_widget $this] yview scroll $count units
#  }
#}

#proc term_see {this index} {
#  if {[term_allowed_scroll $this]} {
#    text_see [term_widget $this] $index
#  }
#}

#proc term_position_cursor_row {this} {
#  upvar #0 $this term
#
#  term_mark_row_col $term(widget) ${this}bottom bottom_row bottom_col
#  term_mark_row_col $term(widget)\
#    "${this}top +$term(row_offset) lines" cur_row cur_col
#  incr cur_row $term(cur_row)
#  set row_index "$cur_row.0"
#
#  while {$cur_row>=$bottom_row} {
#    $term(widget) insert "${this}bottom -1 lines lineend" "\n" {}
#    term_see $this "${this}bottom -1 lines lineend"
#    incr bottom_row
#  }
#
#  $term(widget) mark set $term(insert) $row_index
#}

#proc term_position_cursor_col {this} {
#  upvar #0 $this term
#
#  set cur_col $term(cur_col)
#  if {$cur_col==0} {
#    $term(widget) mark set $term(insert) "$term(insert) linestart"
#  } else {
#    set line \
#      [$term(widget) get "$term(insert) linestart" "$term(insert) lineend"]
#    set linelen [string length $line]
#
#    if {$linelen<$cur_col} {
#      set spacecount [expr {$cur_col-$linelen}]
#      set spaces [format "%*s" $spacecount ""]
#      $term(widget) insert "$term(insert) lineend" $spaces
#    }
#    $term(widget) mark set $term(insert) "$term(insert) linestart +$cur_col c"
#  }
#}

#proc term_position_cursor {this} {
#  term_position_cursor_row $this
#  term_position_cursor_col $this
#}

#proc term_update_tags {this} {
#  upvar #0 $this term
#  if {$term(inverse)} {
#    set color_tags \
#      [list $term(fgcolor)_background $term(bgcolor)_foreground]
#  } else {
#    set color_tags {}
#    if {$term(fgcolor)!=""} {
#      lappend color_tags $term(fgcolor)_foreground
#    }
#    if {$term(bgcolor)!=""} {
#      lappend color_tags $term(bgcolor)_background
#    }
#  }
#  set term(tags) [concat $term(font_tags) $color_tags]
#}

#proc term_reset_tags {this} {
#  upvar #0 $this term
#  set term(fgcolor) ""
#  set term(bgcolor) ""
#  set term(inverse) 0
#  set term(font_tags) {}
#  term_update_tags $this
#}

#proc term_set_charset {this value} {
#  upvar #0 $this term
#  set term(charset) charset$value
#  # Change the current character set
#}

#proc term_set_insertmode {this value} {
#  upvar #0 $this term
#  set term(insert_mode) $value
#}

#proc term_set_inverse {this value} {
#  upvar #0 $this term
#  set term(inverse) $value
#  term_update_tags $this
#}

#proc term_set_fgcolor {this value} {
#  upvar #0 $this term
#  if {$value!=9} {
#    set term(fgcolor) $value
#  } else {
#    set term(fgcolor) ""
#  }
#  term_update_tags $this
#}

#proc term_set_bgcolor {this value} {
#  upvar #0 $this term
#  if {$value!=9} {
#    set term(bgcolor) $value
#  } else {
#    set term(bgcolor) ""
#  }
#  term_update_tags $this
#}

#proc term_set_font_tag {this tag value} {
#  upvar #0 $this term
#  set index [lsearch $term(font_tags) $tag]
#  if {$index!=-1} {
#    if {!$value} {
#      set term(font_tags) [lreplace $term(font_tags) $index $index]
#    }
#  } else {
#    if {$value} {
#      lappend term(font_tags) $tag
#    }
#  }
#  term_update_tags $this
#}

#proc term_set_font_style {this charset value} {
#  upvar #0 $this term
#  set term(charset$charset) $value
#}

#proc term_move_up {this} {
#  upvar #0 $this term
#
#  if {$term(cur_row) > $term(scroll_top)} { 
#    incr term(cur_row) -1 
#    term_position_cursor $this
#  } else {
#    set bottom_index \
#      [$term(widget) index \
#	 "${this}top +[expr {$term(scroll_bottom) + $term(row_offset)}] lines"]
#
#    $term(widget) delete $bottom_index "$bottom_index +1 lines"
#    $term(widget) insert \
#      "${this}top +[expr {$term(row_offset)+$term(scroll_top)}] lines" "\n" {}
#    term_position_cursor $this
#    term_see $this "${this}bottom -1 lines lineend"
#    term_update $term(widget)
#  }
#}

#proc term_insert_line {this count} {
#  upvar #0 $this term
#
#  set bottom_index \
#    "${this}top +[expr {$term(scroll_bottom) + $term(row_offset)}] lines"
#  set top_index "${this}top +[expr {$term(cur_row) + $term(row_offset)}] lines"
#  while {$count > 0} {
#    $term(widget) delete $bottom_index "$bottom_index +1 lines"
#    $term(widget) insert $top_index "\n" {}
#    term_see $this "${this}bottom -1 lines lineend"
#    incr count -1
#  }
#}

#proc term_delete_line {this count} {
#  upvar #0 $this term
#
#  set bottom_index \
#    "${this}top +[expr {$term(scroll_bottom) + $term(row_offset)}] lines"
#  set row_index \
#    "${this}top +[expr {$term(cur_row) + $term(row_offset)}] lines"
#  while {$count > 0} {
#    $term(widget) delete $row_index "$row_index +1 lines"
#    $term(widget) insert $bottom_index "\n" {}
#    term_see $this "${this}bottom -1 lines lineend"
#    incr count -1
#  }
#  term_position_cursor $this
#}

#proc term_delete_char {this count} {
#  upvar #0 $this term
#
#  set linelen \
#    [string length [$term(widget) get $term(insert) "$term(insert) lineend"]]
#  if {$linelen>=$count} {
#    $term(widget) delete $term(insert) "$term(insert) +$count chars"
#  } else {
#    $term(widget) delete $term(insert) "$term(insert) lineend"
#  }
#}

#proc term_insert_char {this count} {
#  upvar #0 $this term
#
#  set linelen \
#    [string length [$term(widget) get $term(insert) "$term(insert) lineend"]]
#  set extra_chars [expr {$linelen+$count+$term(cur_col)-$term(screen_width)}]
#  if {$extra_chars>0} {
#    if {$extra_chars<=$linelen} {
#      $term(widget) delete \
#	"$term(insert) lineend -$extra_chars chars" "$term(insert) lineend"
#    } else {
#      $term(widget) delete $term(insert) "$term(insert) lineend"
#    }
#  }
#  if {$count+$term(cur_col)>$term(screen_width)} {
#    set count [expr {$term(screen_width)-$term(cur_col)}]
#  }
#  $term(widget) insert $term(insert) [format "%${count}s" ""]
#  term_position_cursor $this
#}

#proc term_simple_position_cursor {this} {
#  upvar #0 $this term
#
#  $term(widget) mark set $term(insert) \
#    "${this}top +[expr {$term(cur_row)+$term(row_offset)}] lines +$term(cur_col) chars"
#}

#proc term_force_update {term_widget} {
#  global term_update_pending
#  if {[info exists term_update_pending($term_widget)]} {
#    unset term_update_pending($term_widget)
#  }
#  update idletasks
#}

#proc term_update {term_widget} {
#  global term_update_pending
#  if {[info exists term_update_pending($term_widget)]} {
#    return
#  }
#  set term_update_pending($term_widget) 1
#  after 10 [list term_force_update $term_widget]
#}

#proc term_open_line {this} {
#  upvar #0 $this term
#
#  pause "In Tcl term_open_line"
#  $term(widget) insert "$term(insert) lineend" "\n" {}
#  $term(widget) mark set $term(insert) "$term(insert) +1 lines"
#
#  if {$term(scroll_top)!=0} {
#    set top_row [expr {$term(scroll_top)+$term(row_offset)}]
#    set top_index "${this}top +$top_row lines"
#    set top_index [$term(widget) index $top_index]
#    $term(widget) delete $top_index "$top_index +1 lines"
#  } else {
#    incr term(row_offset)
#    term_scroll $this 1
#  }
#}

#proc term_move_down {this} {
#  upvar #0 $this term
#
#  if {$term(cur_row) == $term(scroll_bottom)} {
#    term_open_line $this
#    term_update $term(widget)
#  } else {
#    if {$term(cur_row)+1 == $term(screen_height)} {
#      return
#    }
#    assert {($term(cur_row)+1)<$term(screen_height)}
#    incr term(cur_row)
#    if {[$term(widget) compare "$term(insert) lineend +1c" >= ${this}bottom]} {
#      $term(widget) insert "$term(insert) lineend" "\n" {}
#    }
#    $term(widget) mark set $term(insert) "$term(insert) lineend +1 c"
#    term_see $this $term(insert)
#  }
#
#  term_position_cursor_col $this
#}

#proc term_cursor_up {this count} {
#  upvar #0 $this term
#
#  while {$count>0} {
#    if {$term(cur_row)==0 || $term(cur_row)==$term(scroll_top)} {
#      break
#    }
#    incr term(cur_row) -1
#    incr count -1
#  }
#  term_position_cursor $this
#}

#proc term_cursor_down {this count} {
#  upvar #0 $this term
#
#  while {$count>0} {
#    if {$term(cur_row)+1==$term(screen_height) || 
#        $term(cur_row)==$term(scroll_bottom)} {
#      break
#    }
#    incr term(cur_row)
#    incr count -1
#  }
#  term_position_cursor $this
#}

#proc term_clear_screen_range {this top bottom} {
#  upvar #0 $this term
#
#  set index [$term(widget) index $top]
#  while {[$term(widget) compare $index < $bottom]} {
#    $term(widget) delete $index "$index lineend"
#    set index [$term(widget) index "$index +1 lines"]
#  }
#}

# Make any unused lines actually visible.
#proc term_show_unused {this} {
#  upvar #0 $this term
#
#  set col $term(cur_col)
#  set row $term(cur_row)
#  set term(cur_col) 0
#  set term(cur_row) [expr {$term(screen_height)-1}]
#  term_position_cursor $this 
#  set term(cur_col) $col
#  set term(cur_row) $row
#  term_position_cursor $this
#}

#proc term_clear_below {this} {
#  upvar #0 $this term
#
#  term_show_unused $this
#  term_force_update $term(widget)
#  term_clear_screen_range $this $term(insert) "${this}bottom -1 chars"
#  term_position_cursor $this
#}

#proc term_clear_screen {this} {
#  upvar #0 $this term
#
#  # Make sure the text has been shown before we erase it.
#  term_force_update $term(widget)
#
#  term_show_unused $this
#  term_clear_screen_range \
#    $this "${this}top +$term(row_offset) lines" ${this}bottom
#
#  term_position_cursor $this
#}

#proc term_clear_to_right {this} {
#  upvar #0 $this term
#
#  $term(widget) delete $term(insert) "$term(insert) lineend"
#}

#proc term_insert {this s} {
#  assert {[string length $s]>0}
#  upvar #0 $this term
#
#  set slen [string length $s]
#  if {$term($term(charset))=="dec_special"} {
#    set s [convert_dec_special $s]
#  }
#
#  if {$term(insert_mode)} {
#    if {$term(cur_col)+$slen >= $term(screen_width)} {
#      $term(widget) delete $term(insert) "$term(insert) lineend"
#    } else {
#      if {[$term(widget) compare $term(insert) < "$term(insert) lineend"]} {
#	set linelen \
#	  [string length \
#	    [$term(widget) get $term(insert) "$term(insert) lineend"]]
#	if {$slen+$linelen>$term(screen_width)} {
#	  set chop [expr {$slen+$linelen-$term(screen_width)}]
#	  $term(widget) delete \
#	    "$term(insert) lineend -$chop c" "$term(insert) lineend"
#	}
#      }
#    }
#  } else {
#    while {$term(cur_col)+$slen > $term(screen_width)} {
#      # Trim the line to the screen width and write the rest to the next line.
#      set inside [expr {$term(screen_width)-$term(cur_col)}]
#      $term(widget) delete $term(insert) "$term(insert) lineend"
#      $term(widget) insert $term(insert) \
#	[string range $s 0 [expr {$inside-1}]] $term(tags)
#      term_cr $this
#      term_move_down $this
#      $term(widget) tag add wrap "$term(insert) -1c" $term(insert) 
#      set s [string range $s $inside end]
#      incr slen -$inside
#    }
#
#    if {[$term(widget) compare $term(insert) < "$term(insert) lineend"]} {
#      set linelen \
#	[string length \
#	  [$term(widget) get $term(insert) "$term(insert) lineend"]]
#      if {$slen>=$linelen} {
#	$term(widget) delete $term(insert) "$term(insert) lineend"
#      } {
#	$term(widget) delete $term(insert) "$term(insert) +$slen chars"
#      }
#    }
#  }
#
#  $term(widget) insert $term(insert) $s $term(tags)
#  incr term(cur_col) $slen
#  global term_insert_handlers
#  eval $term_insert_handlers($term(widget)) $this
#}

#proc term_unexpected {this s} {
#  upvar #0 $this term
#  term_insert $this "<$s>"
#  term_update $term(widget)
#}

#proc term_set_scroll_region {this top bottom} {
#  upvar #0 $this term
#
#  set term(scroll_top) $top
#  incr term(scroll_top) -1
#  set term(scroll_bottom) $bottom
#  incr term(scroll_bottom) -1
#  set term(cur_row) $term(scroll_top)
#  term_position_cursor $this
#}

#proc term_backspace {this} {
#  upvar #0 $this term
#  if {$term(cur_col) > 0 } { 
#    incr term(cur_col) -1
#    term_simple_position_cursor $this
#  }
#}

#proc term_tab {this} {
#  upvar #0 $this term
#  set term(cur_col) [expr {$term(cur_col) - ($term(cur_col) % 8) + 8}]
#  term_position_cursor $this
#}

#proc term_cr {this} {
#  upvar #0 $this term
#  set term(cur_col) 0
#  $term(widget) mark set $term(insert) "$term(insert) linestart"
#}

#proc term_save_cursor {this} {
#  upvar #0 $this term
#
#  set term(saved_row) $term(cur_row)
#  set term(saved_col) $term(cur_col)
#}

#proc term_restore_cursor {this} {
#  upvar #0 $this term
#
#  set term(cur_row) $term(saved_row)
#  set term(cur_col) $term(saved_col)
#  term_position_cursor $this
#}

# Turn on or off a tab at the current column
#proc term_set_tab {this set} {
#  # Not implemented
#}

# Turn off all tabs
#proc term_clear_tabs {this} {
#  # Setting tabs is not implemented, so this isn't either.
#}

#proc term_home_cursor {this} {
#  upvar #0 $this term
#
#  set term(cur_row) 0
#  set term(cur_col) 0
#  term_position_cursor $this
#}

#proc term_cursor_right {this count} {
#  upvar #0 $this term
#  incr term(cur_col) $count
#  term_position_cursor $this
#}

#proc term_cursor_left {this count} {
#  upvar #0 $this term
#  incr term(cur_col) -$count
#  if {$term(cur_col)<0} {
#    set term(cur_col) 0
#  }
#  term_position_cursor $this
#}

#proc term_set_row {this count} {
#  upvar #0 $this term
#
#  set term(cur_row) $count
#  incr term(cur_row) -1
#  term_position_cursor $this
#}

#proc term_set_cursor {this row col} {
#  upvar #0 $this term
#  set term(cur_row) $row
#  incr term(cur_row) -1
#  set term(cur_col) $col
#  incr term(cur_col) -1
#  term_position_cursor $this
#}

# The term that contains the insert mark
#proc focused_term {widget} {
#  global focused_terms
#
#  if {![info exists focused_terms($widget)]} {
#    return {}
#  }
#  return $focused_terms($widget)
#}

#proc term_newline {this} {
#  upvar #0 $this term
#
#  set term(cur_col) 0
#  term_simple_position_cursor $this
#  term_move_down $this
#}

#proc term_widget {termname} {
#  upvar #0 $termname term
#  return $term(widget)
#}

#proc term_is_active {this} {
#  upvar #0 $this term
#  set term_widget $term(widget)
#  global active_terms
#
#  return [expr {[lsearch $active_terms($term_widget) $this]!=-1}]
#}

#proc term_set_screen {this scrnum} {
#  # Do nothing for now.  Eventually need to swap to an alternate display.
#}

#proc term_autowrap {this set} {
#  if {!$set} {
#    error "Non-autowrap not implemented"
#  }
#}

proc term_remove_unused_lines {this} {
  upvar #0 $this term
  term_position_cursor $this

  set last_line_start "${this}bottom -1 lines"
  set last_line_end "${this}bottom -1 lines lineend"
  set term_widget [term_widget $this]
  while {[$term_widget compare $last_line_start == $last_line_end] &&
	 [$term_widget compare ${this}bottom > [term_insert_mark $this]]} {
    $term_widget mark set ${this}bottom $last_line_start
  }
}

proc term_eof {this} {
  puts "term_eof $this"
  upvar #0 $this term

  if {[info exists term]} {
    unset term(spawn_id)
    term_see $this "${this}bottom -1 lines lineend"
    uplevel #0 $term(eof_cmd)
  }
}

proc term_exit {this exit_code} {
  upvar #0 $this term
  set term(exit_code) $exit_code
  term_make_inactive $this
  uplevel #0 $term(exit_cmd)
}

proc term_active_list {widget} {
  global active_terms
  return $active_terms($widget)
}

proc term_make_active {this} {
  upvar #0 $this term
  set term_widget [term_widget $this]
  global active_terms

  lappend active_terms($term_widget) $this
}

proc any_active_terms {widget} {
  global active_terms
  return [expr {[llength $active_terms($widget)]>0}]
}

proc term_make_inactive {this} {
  upvar #0 $this term
  set term_widget [term_widget $this]
  global active_terms

  set index [lsearch $active_terms($term_widget) $this]
  set active_terms($term_widget) \
    [lreplace $active_terms($term_widget) $index $index]
}

proc term_unfocus_all {term_widget} {
  set focused_term_name [focused_term $term_widget]
  if {$focused_term_name!={}} {
    #Change the focused term's index to a normal mark
    upvar #0 $focused_term_name focused_term
    term_set_insert_mark $focused_term_name ${focused_term_name}insert
    $term_widget mark set ${focused_term_name}insert [$term_widget index insert]
    global focused_terms
    unset focused_terms($term_widget)
  }
  bind $term_widget <Any-Enter> {}
}

proc term_focus {this} {
  upvar #0 $this term
  set term_widget [term_widget $this]

  # Notify the client that we are about to focus a window so the client
  # can unfocus their windows.
  global term_focus_handlers
  set code [
    catch [concat $term_focus_handlers($term_widget) [list $this]] message
  ]
  if {$code!=0} {
    puts "Can't call focus handler: $message"
  }

  term_unfocus_all $term_widget

  #Change the new focused term's index to be the insert mark
  set term_insert [term_insert_mark $this]
  $term_widget mark set insert [$term_widget index $term_insert]
  $term_widget mark unset $term_insert
  term_set_insert_mark $this insert

  global focused_terms
  set focused_terms($term_widget) $this
  term_see $this [term_insert_mark $this]
}

#    text "term_insert $this"
#    fgcolor_attr "term_set_fgcolor $this"
#    bgcolor_attr "term_set_bgcolor $this"
#    set_charset "term_set_charset $this"
#    norm_attr "term_reset_tags $this"
#    set_cursor "term_set_cursor $this"
#    bold_attr "#term_set_font_tag $this bold"
#    cursor_right "term_cursor_right $this"
#    tab "term_tab $this"
#    move_down "term_move_down $this"
#    carriage_return "term_cr $this"
#    clear_to_right "term_clear_to_right $this"
#    backspace "term_backspace $this"
#    home_cursor "term_home_cursor $this"
#    move_up "term_move_up $this"
#    inverse_attr "term_set_inverse $this"
#    set_scroll_region "term_set_scroll_region $this"
#    insert_line "term_insert_line $this"
#    clear_screen "term_clear_screen $this"
#    insert_mode "term_set_insertmode $this"
#    save_cursor "term_save_cursor $this"
#    restore_cursor "term_restore_cursor $this"
#    clear_below "term_clear_below $this"
#    set_tab "term_set_tab $this"
#    clear_tabs "term_clear_tabs $this"
#    unexpected "term_unexpected $this"
#    dim_attr "#term_set_font_tag $this dim"
#    italic_attr "#term_set_font_tag $this italic"
#    underline_attr "term_set_font_tag $this underline"
#    set_row "term_set_row $this"
#    set_screen "term_set_screen $this"
#    autowrap "term_autowrap $this"
#    set_font_style "term_set_font_style $this"
#    delete_line "term_delete_line $this"
#    cursor_up "term_cursor_up $this"
#    cursor_down "term_cursor_down $this"
#    cursor_left "term_cursor_left $this"
#    insert_char "term_insert_char $this"
#    delete_char "term_delete_char $this"

proc normal_mode {this} {
  upvar #0 $this term
  set_spawn_term $term(spawn_id) $this
  spawn_set_handlers -i $term(spawn_id) {
    bell "bell"
    app_cursor_keys "term_app_cursor_keys $this"
    cursor_visible "term_cursor_visible $this"
    mouse_reporting "term_mouse_reporting $this"
    mouse_highlighting "term_mouse_highlighting $this"
    app_keypad "#app keypad"
    eof "term_eof $this"
  }
}

proc term_with_spawn_id {spawn_id} {
  global terms
  foreach termvar $terms {
    global $termvar
    upvar #0 $termvar term
    if {[info exists term(spawn_id)]} {
      if {$term(spawn_id)==$spawn_id} {
	return $termvar
      }
    }
  }
  error "no term with spawn id $spawn_id"
}

proc spawn_exit {spawn_id exit_code} {
  set termname [term_with_spawn_id $spawn_id]
  term_exit $termname $exit_code
}

proc send_term {this s} {
  assert {$s!=""}
  upvar #0 $this term

  spawn_send -i $term(spawn_id) -- $s
}

proc term_set_range {this top_index bottom_index} {
  upvar #0 $this term

  set term_widget [term_widget $this]
  set top_index [$term_widget index $top_index]
  $term_widget mark set ${this}bottom $bottom_index
  if {[$term_widget compare ${this}bottom == ${this}top]} {
    # Insert a line that will push any marks at ${this}bottom to the next line.
    set tags1 [$term_widget tag names "${this}bottom -1c"]
    set tags2 [$term_widget tag names "${this}bottom"]
    $term_widget delete "${this}bottom -1c"
    $term_widget insert "${this}bottom -1c" "\n" $tags1
    $term_widget insert "${this}bottom -1c" "\n" $tags2
  }
  $term_widget mark gravity ${this}bottom left
  $term_widget mark set ${this}top $top_index
  $term_widget mark gravity ${this}top left

  term_set_row_offset $this 0
  term_set_cur_row $this 0
  term_set_cur_col $this 0
}

proc init_term {this widget top_index bottom_index rows cols} {
  upvar #0 $this term

  term_set_widget $this $widget
  $widget mark set ${this}insert $top_index
  term_set_insert_mark $this ${this}insert
  term_set_range $this $top_index $bottom_index
  term_set_screen_size $this $rows $cols
  term_set_scroll_region $this 1 [term_screen_height $this]

  #set cursor_prefix "\x1b\O"; #App cursor keys
  set term(cursor_prefix) "\x1b\["; #Normal cursor keys
  term_set_font_style $this 0 usascii
  term_set_font_style $this 1 usascii
  term_set_charset $this 0
  term_set_insertmode $this 0
  term_reset_tags $this
  term_update_tags $this
}

proc create_term {widget} {
  set this [term_alloc]

  global terms
  lappend terms $this

  upvar #0 $this term
  assert {![info exists term]}
  term_set_widget $this $widget
  set term(spawn_pid) -1
  set term(slave) -1

  return $this
}

#Finds the next inactive term in the $dir direction starting with the given
#index in the list of terms.
proc term_index_relative {widget index dir} {
  global terms
  set end_index [llength $terms]

  while {1} {
    incr index $dir
    if {$index<0 || $index>=$end_index} {
      break
    }
    set termname [lindex $terms $index]
    if {[term_widget $termname]==$widget} {
      return $index
    }
  }
  return $index
}

#Finds the last term.
proc term_last {widget} {
  global terms
  if {![info exists terms]} {
    return ""
  } else {
    set index [llength $terms]
    return [lindex $terms [term_index_relative $widget $index -1]]
  }
}

proc term_last_inactive {widget} {
  set termname [term_last $widget]
  if {$termname==""} {
    return $termname
  }
  if {![term_is_active $termname]} {
    return $termname
  }
  return [term_prev $termname 1]
}


#Finds the next inactive term after $termname in the $dir direction
proc term_relative {termname dir inactive_only} {
  upvar #0 $termname term
  global terms
  set index [lsearch $terms $termname]
  set term_widget [term_widget $termname]
  while {1} {
    set index [term_index_relative $term_widget $index $dir]
    set termname [lindex $terms $index]
    if {$termname=="" || !$inactive_only || ![term_is_active $termname]} {
      break
    }
  }
  return $termname
}

#Finds the inactive term immediately before $termname.
proc term_prev {termname inactive_only} {
  return [term_relative $termname -1 $inactive_only]
}


#Finds the inactive term immediately after $termname.
proc term_next {termname inactive_only} {
  return [term_relative $termname 1 $inactive_only]
}

proc delete_term {termname} {
  upvar #0 $termname term
  set term_widget [term_widget $termname]
  if {[focused_term $term_widget]==$termname} {
    term_unfocus_all $term_widget
  }
  if {[info exists term(spawn_id)]} {
    spawn_delete -i $term(spawn_id)
    unset term(spawn_id)
  }
  set tw [term_widget $termname]
  $tw mark unset ${termname}top
  $tw mark unset ${termname}bottom
  $tw mark unset ${termname}insert
  global terms
  set index [lsearch -exact $terms $termname]
  set terms [lreplace $terms $index $index]
  global active_terms
  set index [lsearch -exact $active_terms($tw) $termname]
  set active_terms($tw) [lreplace $active_terms($tw) $index $index]
  unset term
  term_dealloc $termname
}

proc term_key_string {this key} {
  upvar #0 $this term
  if {[string length $key]==1} { 
    return $key
  }
  switch -- $key {
    Up { return "$term(cursor_prefix)A" }
    Down { return "$term(cursor_prefix)B" }
    Right { return "$term(cursor_prefix)C" }
    Left { return "$term(cursor_prefix)D" }
    Home { return "\x1b\[1~" }
    Insert { return "\x1b\[2~" }
    Delete { return "\x1b\[3~" }
    End { return "\x1b\[4~" }
    Prior { return "\x1b\[5~" }
    Next { return "\x1b\[6~" }
    Control_R { return "" }
    Control_L { return "" }
    Shift_R { return "" }
    Shift_L { return "" }
    Alt_R { return "" }
    Alt_L { return "" }
    F1 { return "\x1b\[11~" }
    F2 { return "\x1b\[12~" }
    F3 { return "\x1b\[13~" }
    F4 { return "\x1b\[14~" }
    F5 { return "\x1b\[15~" }
    F6 { return "\x1b\[17~" }
    F7 { return "\x1b\[18~" }
    F8 { return "\x1b\[19~" }
    F9 { return "\x1b\[20~" }
    F10 { return "\x1b\[21~" }
    F11 { return "\x1b\[22~" }
    F12 { return "\x1b\[23~" }
    default { return "" }
  }
}

proc send_focused_term_key {widget key} {
  set focused_term [focused_term $widget]
  set str [term_key_string $focused_term $key]
  if {$str!=""} {
    send_term $focused_term $str
  }
}

proc term_contains {this w index} {
  upvar #0 $this term
  set tw [term_widget $this]
  if {$tw==$w} {
    if {[$tw compare $index >= ${this}top] &&
	[$tw compare $index <= ${this}bottom]} {
      return 1
    }
  }
  return 0
}

proc term_active_at {w index} {
  global active_terms
  foreach termname $active_terms($w) { 
    if [term_contains $termname $w $index] {
      return $termname
    }
  }
  return ""
}

proc term_at {w index} {
  global terms
  if {[info exists terms]} {
    foreach termname $terms {
      if [term_contains $termname $w $index] {
	return $termname
      }
    }
  }
  return ""
}

proc term_list {widget} {
  set list {}
  global terms
  if {[info exists terms]} {
    foreach termname $terms {
      if {[term_widget $termname]==$widget} {
	lappend list $termname
      }
    }
  }
  return $list
}

# This is an implementation of tkTextPrevPos that handles wrapped lines.
proc term_text_prev_pos {w start op} {
  set text ""
  set cur $start
  while {[$w compare $cur > 0.0]} {
      set linestart [$w index "$cur linestart"]
      set text "[$w get $linestart $cur]$text"
      if {[lsearch [$w tag names "$linestart -1c"] wrap]!=-1} {
	set text "X$text"
      } else {
	if {[$w compare $linestart > 1.0]} {
	  set text "\n$text"
	}
      }

      set pos [$op $text end]
      if {$pos >= 0} {
	  set cur [$w index "$linestart - 1c + $pos c"]
	  return $cur
      }
      set cur [$w index "$linestart - 1c"]
  }
  return 0.0
}

# This is an implementation of tkTextNextPos that handles wrapped lines.
proc term_text_next_pos {w start op} {
  set text ""
  set cur $start
  while {[$w compare $cur < end]} {
      set text "$text[$w get $cur "$cur lineend"]"
      if {[lsearch [$w tag names "$cur lineend"] wrap]!=-1} {
	set text "${text}X"
      } else {
	set text "$text\n"
      }
      set pos [$op $text 0]
      if {$pos >= 0} {
	  return [$w index "$start + $pos c"]
      }
      set cur [$w index "$cur lineend +1c"]
  }
  return end
}

proc term_text_select_to {w x y} {
    global tkPriv

    set cur [tkTextClosestGap $w $x $y]
    if [catch {$w index anchor}] {
        $w mark set anchor $cur
    }
    set anchor [$w index anchor]
    if {[$w compare $cur != $anchor] || (abs($tkPriv(pressX) - $x) >= 3)} {
        set tkPriv(mouseMoved) 1
    }
    switch $tkPriv(selectMode) {
        char {
            if [$w compare $cur < anchor] {
                set first $cur
                set last anchor
            } else {
                set first anchor
                set last $cur
            }
        }
        word {
            if [$w compare $cur < anchor] {
                set first [term_text_prev_pos $w "$cur + 1c" tcl_wordBreakBefore]
                set last [term_text_next_pos $w "anchor" tcl_wordBreakAfter]
            } else {
                set first [term_text_prev_pos $w anchor tcl_wordBreakBefore]
                set last [term_text_next_pos $w "$cur - 1c" tcl_wordBreakAfter]
            }
        }
        line {
            if [$w compare $cur < anchor] {
                set first [$w index "$cur linestart"]
                set last [$w index "anchor - 1c lineend + 1c"]
            } else {
                set first [$w index "anchor linestart"]
                set last [$w index "$cur lineend + 1c"]
            }
        }
    }
    if {$tkPriv(mouseMoved) || ($tkPriv(selectMode) != "char")} {
        $w tag remove sel 0.0 $first
        $w tag add sel $first $last
        $w tag remove sel $last end
	term_force_update $w
    }
}

proc term_text_auto_scan {w} {
    global tkPriv
    if {![winfo exists $w]} return
    if {$tkPriv(y) >= [winfo height $w]} {
        $w yview scroll 2 units
    } elseif {$tkPriv(y) < 0} {
        $w yview scroll -2 units
    } elseif {$tkPriv(x) >= [winfo width $w]} {
        $w xview scroll 2 units
    } elseif {$tkPriv(x) < 0} {
        $w xview scroll -2 units
    } else {
        return
    }
    term_text_select_to $w $tkPriv(x) $tkPriv(y)
    set tkPriv(afterId) [after 50 term_text_auto_scan $w]
}

proc term_text_triple_button_1 {w x y} {
  set termname [term_at $w [tkTextClosestGap $w $x $y]]
  if {$termname!=""} {
    global tkPriv
    set tkPriv(selectMode) line
    term_text_select_to $w $x $y
  } else {
    puts "No term under cursor"
  }
}

proc term_set_colors {widget} {
  set code 0
  set fgcolor [$widget cget -foreground]
  set bgcolor [$widget cget -background]
  $widget tag configure _background -foreground $bgcolor
  $widget tag configure _foreground -background $fgcolor
  foreach color {black red green yellow blue magenta cyan white} {
    $widget tag configure ${code}_foreground -foreground $color
    $widget tag configure ${code}_background -background $color
    incr code
  }
}

proc term_init_widget {widget focus_handler} {
  global active_terms
  set active_terms($widget) {}
  global term_focus_handlers
  set term_focus_handlers($widget) $focus_handler
  $widget configure -state normal
  $widget tag configure bold \
    -font [concat [font actual [$widget cget -font]] -weight bold]
  $widget tag configure underline -underline 1
  term_set_colors $widget
  bind $widget <ButtonRelease-1> {
  }
  bind $widget <ButtonPress-2> {
    break
  }
  bind $widget <B2-Motion> {
    break
  }
  bind $widget <Triple-Button-1> {
    term_text_triple_button_1 %W %x %y
    break
  }
  bind $widget <B1-Motion> {
    set tkPriv(x) %x
    set tkPriv(y) %y
    term_text_select_to %W %x %y
    break
  }
  bind $widget <B1-Leave> {
    set tkPriv(x) %x
    set tkPriv(y) %y
    term_text_auto_scan %W
    break
  }
}

proc assume_term {this orig_termname {eof_cmd {}} {exit_cmd {}}} {
  upvar #0 $this term
  upvar #0 $orig_termname orig_term

  set term(exit_cmd) $exit_cmd
  set term(eof_cmd) $eof_cmd
  set term(dir) $orig_term(dir)
  set term(cmd) $orig_term(cmd)
  set term(slave) $orig_term(slave)
  set orig_term(slave) {}
  set term(spawn_pid) $orig_term(spawn_pid)
  foreach member {spawn_id pty_open saved_row saved_col} {
    if {[info exists orig_term($member)]} {
      set term($member) $orig_term($member)
      unset orig_term($member)
    }
  }
  term_set_cur_col $this [term_cur_col $orig_termname]
  term_set_cur_row $this [term_cur_row $orig_termname]
  term_set_row_offset $this [term_row_offset $orig_termname]
  term_set_scroll_top $this [term_scroll_top $orig_termname]
  term_set_scroll_bottom $this [term_scroll_bottom $orig_termname]

  if {[term_is_active $orig_termname]} {
    term_position_cursor $this
    term_make_active $this
    normal_mode $this
  }
}

proc term_close_pty {this} {
  upvar #0 $this term
  assert {$term(pty_open)}
  puts "Closing pty"
  set unread [spawn_close -i $term(spawn_id)]
  unset term(pty_open)
  set term_widget [term_widget $this]
  if {[focused_term $term_widget]==$this} {
    term_unfocus_all $term_widget
  }
  return $unread
}

proc term_open_pty {this {eof_cmd {}}} {
  upvar #0 $this term
  assert {![info exists term(spawn_id)]}
  puts "Opening pty"
  set term(spawn_id) [spawn_open]
  assert {![info exists term(pty_open)]}
  set term(pty_open) 1
  set term(slave_name) $spawn_out(slave,name)
  set term(eof_cmd) $eof_cmd
  spawn_stty -i $term(spawn_id) \
    rows [term_screen_height $this] cols [term_screen_width $this]
  normal_mode $this
}

proc term_line_count {this} {
  upvar #0 $this term
  set term_widget [term_widget $this]
  term_mark_row_col $this ${this}top toprow topcol
  term_mark_row_col $this ${this}bottom bottomrow bottomcol
  return [expr {$bottomrow-$toprow}]
}

proc term_set_screen_size {this rows cols} {
  upvar #0 $this term
  if {[info exists term(spawn_id)]} {
    spawn_stty -i $term(spawn_id) rows $rows cols $cols
  }
  term_set_screen_height $this $rows
  term_set_screen_width $this $cols
  term_set_scroll_top $this 0
  term_set_scroll_bottom $this [expr {$rows-1}]

  # Check to see if the term has a contents.
  if {[term_insert_mark $this]==""} {
    return
  }

  # Readjust the contents to the new width taking into consideration 
  # wrapped lines.
  set pos ${this}top
  set term_widget [term_widget $this]
  while {[$term_widget compare $pos < ${this}bottom]} {
    # Join wrapped lines together
    while {[lsearch [$term_widget tag names "$pos lineend"] wrap]!=-1} {
      $term_widget delete "$pos lineend"
    }
    # Split lines apart
    set linelen [string length [$term_widget get "$pos" "$pos lineend"]]
    while {$linelen>$cols} {
      $term_widget insert "$pos +$cols c" "\n" wrap
      set pos [$term_widget index "$pos +1 lines"]
      incr linelen -$cols
    }
    set pos [$term_widget index "$pos +1 lines"]
  }

  # Adjust the row offset
  set numlines [term_line_count $this]
  set row_offset [expr {$numlines-$rows}]
  if {$row_offset<0} {
    set row_offset 0
  }
  term_set_row_offset $this $row_offset
  term_mark_row_col $this ${this}top toprow topcol
  term_mark_row_col $this [term_insert_mark $this] insertrow insertcol
  term_set_cur_row $this [expr {$insertrow-$toprow-$row_offset}]
  if {[term_cur_row $this]<0} {
    term_set_cur_row $this 0
  }
  assert {[term_cur_row $this]<=[term_screen_height $this]}
  term_see $this "${this}bottom -1 lines"
}

proc term_kill {this signame} {
  upvar #0 $this term
  spawn_kill -i $term(spawn_id) $signame
}

proc run_term {this command {exit_cmd {}}} {
  upvar #0 $this term
  global env

  set term(exit_cmd) $exit_cmd
  set term(slave) {}

  set term_widget [term_widget $this]
  set screen_width [$term_widget cget -width]
  set env(TERM) xterm
  # Use after script to avoid fouling up state during signal handling
  term_make_active $this
  global config
  if {![regexp {^ *\((.*)\) *$} $command match subcmd]} {
    set subcmd $command
  }
  set spawn_cmd [concat $config(shell_command) [list $subcmd]]
  puts "$this: Spawning $spawn_cmd"
  set term(spawn_pid) [eval spawn_exec -i $term(spawn_id) $spawn_cmd]
}

# Remove any lines in the term above the row_offset, and clear the lines
# between the row_offset and the bottom.
proc term_clear {this} {
  upvar #0 $this term
  # Delete the lines above the row offset
  set term_widget [term_widget $this]
  set row_offset [term_row_offset $this]
  $term_widget delete "${this}top" "${this}top +$row_offset lines"
  if {[$term_widget compare ${this}top == ${this}bottom]} {
    # If there are no lines remaining make the term have a single line.
    set old_top_index [$term_widget index ${this}top]
    set tags1 [$term_widget tag names "${this}top -1c"]
    
    # Temporarily change the gravity of the insert mark so that it doesn't
    # move if it is at the end of the line.
    $term_widget mark gravity insert left
    $term_widget insert "${this}top -1c" "\n" $tags1
    $term_widget mark gravity insert right
    $term_widget insert "${this}top -1c" "\n" {}

    set index "${this}top -1c"
    $term_widget delete $index
    # The top mark gets moved, so reset it
    $term_widget mark set ${this}top $old_top_index
    # The bottom mark is anchored on the left, so it doesn't move.  We
    # have to move it manually.
    $term_widget mark set ${this}bottom "${this}top +1 lines"
  }
  term_set_row_offset $this 0
  term_clear_screen_range $this ${this}top ${this}bottom
  term_home_cursor $this
}

proc term_app_cursor_keys {this set} {
  upvar #0 $this term

  if {$set} {
    set term(cursor_prefix) "\x1bO"
  } else {
    set term(cursor_prefix) "\x1b\["
  }
}

proc term_cursor_visible {this scrnum} {
  # Could make the cursor be the same color as the background.
}

# Turn on or off X11 mouse reporting
proc term_mouse_reporting {this set} {
  # Not implemented
}

# Turn on or off X11 mouse highlighting
proc term_mouse_highlighting {this set} {
  # Not implemented
}

